<?php
// $Id: customfilter.class.inc,v 1.1.2.7 2009/07/22 02:43:08 kiam Exp $

/**
 * @file
 * CustomFilter class definition.
 */

/**
 * @addtogroup customfilter
 * @{
 */

class CustomFilter {
  public $node = NULL;
  
  private static $instance;
  private $vars = array();
  
  public function __call($name, $arguments) {
    $flist = module_invoke_all('customfilter_functions');
    
    if (isset($flist[$name])) {
      $result = call_user_func_array($flist[$name]['function'], $arguments);
      if (isset($result)) {
        return $result;
      }
      else {
        return '';
      }
    }
    else {
      return '';
    }
  }
  
  private function __clone() {}
  
  private function __construct() {}
  
  public function __get($name) {
    if (array_key_exists($name, $this->vars)) {
      return $this->vars[$name];
    }
    
    return NULL;
  }
  
  public function __isset($name) {
    return isset($this->vars[$name]);
  }
  
  public function __set($name, $value) {
    $this->vars[$name] = $value;
  }
  
  public function __unset($name) {
    unset($this->vars[$name]);
  }
  
  public static function singleton() {
    if (!isset(self::$instance)) {
      self::$instance = new CustomFilter();
    }
    
    return self::$instance;
  }
}

/**
 * @} End of "addtogroup customfilter".
 */